<?php
/*
Plugin Name: GDPR Cookies
Description: GDPR allows you to elegantly inform users that your site uses cookies and to comply with the EU cookie law GDPR regulations.
Version: 1.3
Author: opmc
Author URI: http://opmc.biz 
Plugin URI: 
Woo: 5795619:37ea3a94e47bb82ede2fae9bb110e7ff
License: GNU General Public License v3.0
License URI: http://www.gnu.org/licenses/gpl-3.0.html
Text Domain: 
Domain Path: /languages
*/

// exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
* Required functions.
*/
if ( ! function_exists( 'woothemes_queue_update' ) ) {
	require_once( 'woo-includes/woo-functions.php' );
} 

/**
* Plugin updates
*/
woothemes_queue_update(plugin_basename(__FILE__), '', '');



// set plugin instance
$cookie_notice = new Cookie_Notice();

include_once( plugin_dir_path( __FILE__ ) . 'includes/upgrade.php' );

/**
* Cookie Notice class.
*
* @class Cookie_Notice
* @version 1.2.48
*/
class Cookie_Notice {

	/**
	 * Register Plugins setting fields
	 *
	 * @var $defaults
	 */
	private $defaults = array(
		'general' => array(
			'position' => 'bottom',
			'message_text' => '',
			'css_style' => 'bootstrap',
			'css_class' => 'button',
			'accept_text' => '',
			'refuse_text' => '',
			'refuse_opt' => 'no',
			'refuse_code' => '',
			'refuse_code_head' => '',
			'revoke_cookies' => false,
			'revoke_cookies_opt' => 'automatic',
			'revoke_text' => '',
			'redirection' => false,
			'see_more' => 'no',
			'link_target' => '_blank',
			'link_position' => 'banner',
			'time' => 'month',
			'hide_effect' => 'fade',
			'on_scroll' => false,
			'on_scroll_offset' => 100,
			'colors' => array(
				'text' => '#fff',
				'bar' => '#000'
			),
			'see_more_opt' => array(
				'text' => '',
				'link_type' => 'page',
				'id' => 'empty',
				'link' => '',
				'sync' => false
			),
			'script_placement' => 'header',
			'translate' => true,
			'deactivation_delete' => 'no',
			'update_version' => 1,
			'update_notice' => true,
			'update_delay_date' => 0
		),
		'version' => '1.2.48',
		'accepted_cookie_count' => 0
	);
	private $positions = array();
	private $styles = array();
	private $choices = array();
	private $links = array();
	private $link_targets = array();
	private $link_positions = array();
	private $colors = array();
	private $options = array();
	private $effects = array();
	private $times = array();
	private $notices = array();
	private $script_placements = array();
	private $locationsetting = array ('-- Select --','Add All EU','Ignore Geo Location','Clear All');
	private $european_countryList = array(
	'Russia',
	'Germany',
	'United Kingdom',
	'France',
	'Italy',
	'Spain',
	'Ukraine',
	'Poland',
	'Romania',
	'Netherlands',
	'Belgium',
	'Czechia',
	'Greece',
	'Portugal',
	'Sweden',
	'Hungary',
	'Belarus',
	'Austria',
	'Serbia',
	'Switzerland',
	'Bulgaria',
	'Denmark',
	'Finland',
	'Slovakia',
	'Norway',
	'Ireland',
	'Croatia',
	'Moldova',
	'Bosnia and Herzegovina',
	'Albania',
	'Lithuania',
	'Republic of North Macedonia',
	'Slovenia',
	'Latvia',
	'Estonia',
	'Montenegro',
	'Luxembourg',
	'Malta',
	'Iceland',
	'Andorra',
	'Monaco',
	'Liechtenstein',
	'San Marino', 
	'Holy See'
	);
	
	private $countryList = array (
	'Afghanistan',
	'Albania',
	'Algeria',
	'American Samoa',
	'Andorra',
	'Angola',
	'Anguilla',
	'Antarctica',
	'Antigua and Barbuda',
	'Argentina',
	'Armenia',
	'Aruba',
	'Australia',
	'Austria',
	'Azerbaijan',
	'Bahamas (the)',
	'Bahrain',
	'Bangladesh',
	'Barbados',
	'Belarus',
	'Belgium',
	'Belize',
	'Benin',
	'Bermuda',
	'Bhutan',
	'Bolivia (Plurinational State of)',
	'Bonaire, Sint Eustatius and Saba',
	'Bosnia and Herzegovina',
	'Botswana',
	'Bouvet Island',
	'Brazil',
	'British Indian Ocean Territory (the)',
	'Brunei Darussalam',
	'Bulgaria',
	'Burkina Faso',
	'Burundi',
	'Cabo Verde',
	'Cambodia',
	'Cameroon',
	'Canada',
	'Cayman Islands (the)',
	'Central African Republic (the)',
	'Chad',
	'Chile',
	'China',
	'Christmas Island',
	'Cocos (Keeling) Islands (the)',
	'Colombia',
	'Comoros (the)',
	'Congo (the Democratic Republic of the)',
	'Congo (the)',
	'Cook Islands (the)',
	'Costa Rica',
	'Croatia',
	'Cuba',
	'Curaçao',
	'Cyprus',
	'Czechia',
	"Côte d'Ivoire",
	'Denmark',
	'Djibouti',
	'Dominica',
	'Dominican Republic (the)',
	'Ecuador',
	'Egypt',
	'El Salvador',
	'Equatorial Guinea',
	'Eritrea',
	'Estonia',
	'Eswatini',
	'Ethiopia',
	'Falkland Islands (the) [Malvinas]',
	'Faroe Islands (the)',
	'Fiji',
	'Finland',
	'France',
	'French Guiana',
	'French Polynesia',
	'French Southern Territories (the)',
	'Gabon',
	'Gambia (the)',
	'Georgia',
	'Germany',
	'Ghana',
	'Gibraltar',
	'Greece',
	'Greenland',
	'Grenada',
	'Guadeloupe',
	'Guam',
	'Guatemala',
	'Guernsey',
	'Guinea',
	'Guinea-Bissau',
	'Guyana',
	'Haiti',
	'Heard Island and McDonald Islands',
	'Holy See',
	'Honduras',
	'Hong Kong',
	'Hungary',
	'Iceland',
	'India',
	'Indonesia',
	'Iran (Islamic Republic of)',
	'Iraq',
	'Ireland',
	'Isle of Man',
	'Israel',
	'Italy',
	'Jamaica',
	'Japan',
	'Jersey',
	'Jordan',
	'Kazakhstan',
	'Kenya',
	'Kiribati',
	"Korea (the Democratic People's Republic of)",
	'Korea (the Republic of)',
	'Kuwait',
	'Kyrgyzstan',
	"Lao People's Democratic Republic (the)",
	'Latvia',
	'Lebanon',
	'Lesotho',
	'Liberia',
	'Libya',
	'Liechtenstein',
	'Lithuania',
	'Luxembourg',
	'Macao',
	'Madagascar',
	'Malawi',
	'Malaysia',
	'Maldives',
	'Mali',
	'Malta',
	'Marshall Islands (the)',
	'Martinique',
	'Mauritania',
	'Mauritius',
	'Mayotte',
	'Mexico',
	'Micronesia (Federated States of)',
	'Moldova',
	'Monaco',
	'Mongolia',
	'Montenegro',
	'Montserrat',
	'Morocco',
	'Mozambique',
	'Myanmar',
	'Namibia',
	'Nauru',
	'Nepal',
	'Netherlands',
	'New Caledonia',
	'New Zealand',
	'Nicaragua',
	'Niger (the)',
	'Nigeria',
	'Niue',
	'Norfolk Island',
	'Northern Mariana Islands (the)',
	'Norway',
	'Oman',
	'Pakistan',
	'Palau',
	'Palestine, State of',
	'Panama',
	'Papua New Guinea',
	'Paraguay',
	'Peru',
	'Philippines (the)',
	'Pitcairn',
	'Poland',
	'Portugal',
	'Puerto Rico',
	'Qatar',
	'Republic of North Macedonia',
	'Romania',
	'Russia',
	'Rwanda',
	'Réunion',
	'Saint Barthélemy',
	'Saint Helena, Ascension and Tristan da Cunha',
	'Saint Kitts and Nevis',
	'Saint Lucia',
	'Saint Martin (French part)',
	'Saint Pierre and Miquelon',
	'Saint Vincent and the Grenadines',
	'Samoa',
	'San Marino',
	'Sao Tome and Principe',
	'Saudi Arabia',
	'Senegal',
	'Serbia',
	'Seychelles',
	'Sierra Leone',
	'Singapore',
	'Sint Maarten (Dutch part)',
	'Slovakia',
	'Slovenia',
	'Solomon Islands',
	'Somalia',
	'South Africa',
	'South Georgia and the South Sandwich Islands',
	'South Sudan',
	'Spain',
	'Sri Lanka',
	'Sudan (the)',
	'Suriname',
	'Svalbard and Jan Mayen',
	'Sweden',
	'Switzerland',
	'Syrian Arab Republic',
	'Taiwan (Province of China)',
	'Tajikistan',
	'Tanzania, United Republic of',
	'Thailand',
	'Timor-Leste',
	'Togo',
	'Tokelau',
	'Tonga',
	'Trinidad and Tobago',
	'Tunisia',
	'Turkey',
	'Turkmenistan',
	'Turks and Caicos Islands (the)',
	'Tuvalu',
	'Uganda',
	'Ukraine',
	'United Arab Emirates (the)',
	'United Kingdom',
	'United States Minor Outlying Islands (the)',
	'United States of America (the)',
	'Uruguay',
	'Uzbekistan',
	'Vanuatu',
	'Venezuela (Bolivarian Republic of)',
	'Viet Nam',
	'Virgin Islands (British)',
	'Virgin Islands (U.S.)',
	'Wallis and Futuna',
	'Western Sahara',
	'Yemen',
	'Zambia',
	'Zimbabwe',
	'Åland Islands'
	);

	/**
	 * Constructor.
	 */
	public function __construct() {
		
		register_activation_hook( __FILE__, array( $this, 'activation' ) );
		register_deactivation_hook( __FILE__, array( $this, 'deactivation' ) );

		// settings
		$this->options = array(
			'general' => array_merge( $this->defaults['general'], get_option( 'cookie_notice_options', $this->defaults['general'] ) )
		);




		if ( ! isset( $this->options['general']['see_more_opt']['sync'] ) ) {
			$this->options['general']['see_more_opt']['sync'] = $this->defaults['general']['see_more_opt']['sync'];
		}

		// actions
	
		add_action( 'wp_head', array( $this, 'gdpr_google_analytics' ) );
		
		add_action( 'wp_head', array( $this, 'cn_google_adwords' ) );
		add_action( 'init', array( $this, 'register_shortcodes' ) );
		add_action( 'init', array( $this, 'wpsc_add_cookie' ) );
		//add_action( 'init', array( $this, 'get_customer_ip' ) );
		add_action( 'init', array( $this, 'create_txt_file' ) );
		add_action( 'init', array( $this, 'track_user_activity_txt_file' ) );
		//add_action( 'init', array( $this, 'custom_cookie' ) );
		//add_action( 'init', array( $this, 'revoke_customer_cookie' ) );
		add_action( 'template_redirect', array( $this, 'user_activity_status' ) );
		//add_action('admin_menu', array( $this, 'add_users_menu' ));

		add_action( 'admin_init', array( $this, 'register_settings' ) );
		add_action( 'admin_init', array( $this, 'update_notice' ) );
		add_action( 'admin_menu', array( $this, 'admin_menu_options' ) );
		add_action( 'plugins_loaded', array( $this, 'load_textdomain' ) );
		add_action( 'after_setup_theme', array( $this, 'gdpr_load_defaults' ) );
		
		add_action( 'wp_enqueue_scripts', array( $this, 'wp_enqueue_scripts' ) );
		add_action( 'wp_head', array( $this, 'wp_print_header_scripts' ) );
		add_action( 'wp_print_footer_scripts', array( $this, 'wp_print_footer_scripts' ) );
		add_action( 'wp_footer', array( $this, 'add_cookie_notice' ), 1000 );
		add_action( 'wp_ajax_cn_dismiss_notice', array( $this, 'dismiss_notice' ) );

		// Ajax for counting accept cookie

		add_action( 'wp_ajax_custom_cookie', array( $this,'custom_cookie' ));
		add_action( 'wp_ajax_nopriv_custom_cookie', array( $this,'custom_cookie' ));
		
		add_action( 'wp_ajax_get_customer_ip', array( $this,'get_customer_ip' ));
		add_action( 'wp_ajax_nopriv_get_customer_ip', array( $this,'get_customer_ip' ));
		// Ajax for counting accept cookie 


		// filters
		add_filter( 'plugin_row_meta', array( $this, 'plugin_row_meta' ), 10, 2 );
		add_filter( 'plugin_action_links', array( $this, 'plugin_action_links' ), 10, 2 );
		add_filter( 'body_class', array( $this, 'gdpr_change_body_class' ) );

		add_action( 'wp_ajax_revoke_customer_cookie', array( $this,'revoke_customer_cookie' ));
		add_action( 'wp_ajax_nopriv_revoke_customer_cookie', array( $this,'revoke_customer_cookie' ));
		
		// load other files
		include_once( plugin_dir_path( __FILE__ ) . 'includes/functions.php' );
		add_action( 'admin_enqueue_scripts', array($this,'wpdocs_selectively_enqueue_admin_script' ));
		add_action( 'admin_enqueue_scripts', array( $this, 'admin_enqueue_scripts' ) );
		
		if ( is_admin() ) {
			add_action( 'admin_notices', array( $this, 'admin_notices_gdpr_cookies' ) );
		}
	}


	/**
	 * Load plugin defaults
	 */
	public function gdpr_load_defaults() {
		$this->positions = array(
			'top' => __( 'Top', 'cookie-notice' ),
			'bottom' => __( 'Bottom', 'cookie-notice' )
		);

		$this->styles = array(
			'none' => __( 'None', 'cookie-notice' ),
			'wp-default' => __( 'WordPress', 'cookie-notice' ),
			'bootstrap' => __( 'Bootstrap', 'cookie-notice' )
		);
		
		$this->revoke_opts = array(
			'automatic' => __( 'Automatic', 'cookie-notice' ),
			'manual' => __( 'Manual', 'cookie-notice' )
		);

		$this->links = array(
			'page' => __( 'Page link', 'cookie-notice' ),
			'custom' => __( 'Custom link', 'cookie-notice' )
		);

		$this->link_targets = array(
			'_blank' => __( 'Open page in new window', 'cookie-notice' ),
			'_self' => __( 'Open page in same window', 'cookie-notice' )
		);

		$this->link_positions = array(
			'banner' => __( 'Button', 'cookie-notice' ),
			'message' => __( 'Text', 'cookie-notice' )
		);

		$this->colors = array(
			'text' => __( 'Text color', 'cookie-notice' ),
			'bar' => __( 'Bar color', 'cookie-notice' ),
		);

		$this->times = array(
			'hour' => array( __( 'An hour', 'cookie-notice' ), 3600 ),
			'day' => array( __( '1 day', 'cookie-notice' ), 86400 ),
			'week' => array( __( '1 week', 'cookie-notice' ), 604800 ),
			'month' => array( __( '1 month', 'cookie-notice' ), 2592000 ),
			'3months' => array( __( '3 months', 'cookie-notice' ), 7862400 ),
			'6months' => array( __( '6 months', 'cookie-notice' ), 15811200 ),
			'year' => array( __( '1 year', 'cookie-notice' ), 31536000 ),
			'infinity' => array( __( 'infinity', 'cookie-notice' ), 2147483647 )
		);

		$this->effects = array(
			'none' => __( 'None', 'cookie-notice' ),
			'fade' => __( 'Fade', 'cookie-notice' ),
			'slide' => __( 'Slide', 'cookie-notice' )
		);

		$this->script_placements = array(
			'header' => __( 'Header', 'cookie-notice' ),
			'footer' => __( 'Footer', 'cookie-notice' ),
		);

		if ( true === $this->options['general']['translate'] ) {
			$this->options['general']['translate'] = false;

			$this->options['general']['message_text'] = __( 'We use cookies to ensure that we give you the best experience on our website. If you continue to use this site we will assume that you are happy with it.', 'cookie-notice' );
			$this->options['general']['accept_text'] = __( 'Ok', 'cookie-notice' );
			$this->options['general']['refuse_text'] = __( 'No', 'cookie-notice' );
			$this->options['general']['revoke_text'] = __( 'Revoke cookies', 'cookie-notice' );
			$this->options['general']['see_more_opt']['text'] = __( 'Privacy policy', 'cookie-notice' );

			update_option( 'cookie_notice_options', $this->options['general'] );
		}

		// WPML >= 3.2
		if ( defined( 'ICL_SITEPRESS_VERSION' ) && version_compare( ICL_SITEPRESS_VERSION, '3.2', '>=' ) ) {
			$this->register_wpml_strings();
			// WPML and Polylang compatibility
		} elseif ( function_exists( 'icl_register_string' ) ) {
			icl_register_string( 'Cookie Notice', 'Message in the notice', $this->options['general']['message_text'] );
			icl_register_string( 'Cookie Notice', 'Button text', $this->options['general']['accept_text'] );
			icl_register_string( 'Cookie Notice', 'Refuse button text', $this->options['general']['refuse_text'] );
			icl_register_string( 'Cookie Notice', 'Revoke button text', $this->options['general']['revoke_text'] );
			icl_register_string( 'Cookie Notice', 'Privacy policy text', $this->options['general']['see_more_opt']['text'] );
			icl_register_string( 'Cookie Notice', 'Custom link', $this->options['general']['see_more_opt']['link'] );
		}
	}

	/**
	* Update notice.
	*/
	public function update_notice() {
		if ( ! current_user_can( 'install_plugins' ) ) {
			return;
		}

		$current_update = 2;

		// get current time
		$current_time = time();

		if ( $this->options['general']['update_version'] < $current_update ) {
			// check version, if update version is lower than plugin version, set update notice to true
			$this->options['general'] = array_merge( $this->options['general'], array( 'update_version' => $current_update, 'update_notice' => true ) );

			update_option( 'cookie_notice_options', $this->options['general'] );

			// set activation date
			$activation_date = get_option( 'gdpr_cookie_activation_date' );
			if ( false === $activation_date) {
				update_option( 'gdpr_cookie_activation_date', $current_time );
			}
		}

		
	}

	/**
	* Add admin notices.
	* 
	* @param string $html
	* @param string $status
	* @param bool $paragraph
	*/
	public function add_notice( $html = '', $status = 'error', $paragraph = true ) {
		$this->notices[] = array(
			'html' => $html,
			'status' => $status,
			'paragraph' => $paragraph
		);

		add_action( 'admin_notices', array( $this, 'display_notice') );
	}

	/**
	* Print admin notices.
	* 
	* @return mixed
	*/
	public function display_notice() {
		foreach ( $this->notices as $notice ) {
			echo '
<div class="' . esc_attr($notice['status']) . '">
' . ( $notice['paragraph'] ? '<p>' : '' ) . '
' . esc_html($notice['html']) . '
' . ( $notice['paragraph'] ? '</p>' : '' ) . '
</div>';
		}
	}

	/**
	* Print admin scripts.
	* 
	* @return mixed
	*/
	public function admin_inline_js() {
		if ( ! current_user_can( 'install_plugins' ) ) {
			return;
		}
		?>
		<script type="text/javascript">
			( function ( $ ) {
				$( document ).ready( function () {
					// save dismiss state
					$( '.cn-notice.is-dismissible' ).on( 'click', '.notice-dismiss, .cn-dismissible-notice', function ( e ) {
						var notice_action = 'hide';
						
						if ( $( e.currentTarget ).hasClass( 'cn-delay-notice' ) ) {
							notice_action = 'delay'
						}
						
						$.post( ajaxurl, {
							action: 'cn_dismiss_notice',
							notice_action: notice_action,
							url: '<?php echo esc_url(admin_url( 'admin-ajax.php' )); ?>',
							nonce: '<?php echo esc_html(wp_create_nonce( 'cn_dismiss_notice' )); ?>'
						} );
					
						$( e.delegateTarget ).slideUp( 'fast' );
					} );
				} );



			} )( jQuery );
		</script>
		<?php
	}

	/**
	* Dismiss notice.
	*/
	public function dismiss_notice() {
		if ( ! current_user_can( 'install_plugins' ) ) {
			return;
		}

		if ( !empty(wp_verify_nonce( sanitize_text_field( $_REQUEST['nonce'] ), 'cn_dismiss_notice' ) )) {
			$notice_action = empty( sanitize_text_field($_REQUEST['notice_action'] )) || sanitize_text_field($_REQUEST['notice_action']) === 'hide' ? 'hide' : sanitize_text_field( $_REQUEST['notice_action'] );

			switch ( $notice_action ) {
				// delay notice
				case 'delay':
					// set delay period to 1 week from now
					$this->options['general'] = array_merge( $this->options['general'], array( 'update_delay_date' => time() + 1209600 ) );
					update_option( 'cookie_notice_options', $this->options['general'] );
					break;

				// hide notice
				default:
					$this->options['general'] = array_merge( $this->options['general'], array( 'update_notice' => false ) );
					$this->options['general'] = array_merge( $this->options['
general'], array( 'update_delay_date' => 0 ) );

					update_option( 'cookie_notice_options', $this->options['general'] );
			}
		}

		exit;
	}

	/**
	* Add new body classes.
	*
	* @param array $classes Body classes
	* @return array
	*/
	public function gdpr_change_body_class( $classes ) {
		if ( is_admin() ) {
			return $classes;
		}

		if ( $this->cookies_set() ) {
			$classes[] = 'cookies-set';

			if ( $this->cookies_accepted() ) {
				$classes[] = 'cookies-accepted';
			} else {
				$classes[] = 'cookies-refused';
			}
		} else {
			$classes[] = 'cookies-not-set';
		}

		return $classes;
	}

	/**
	 * Register shortcode.
	 *
	 * @return void
	 */
	public function register_shortcodes() {
		add_shortcode( 'cookies_accepted', array( $this, 'cookies_accepted_shortcode' ) );
		add_shortcode( 'cookies_revoke', array( $this, 'cookies_revoke_shortcode' ) );
		add_shortcode( 'cookies_policy_link', array( $this, 'cookies_policy_link_shortcode' ) );
	}

	/**
	 * Register cookies accepted shortcode.
	 *
	 * @param array $args
	 * @param mixed $content
	 * @return mixed
	 */
	public function cookies_accepted_shortcode( $args, $content ) {
		if ( $this->cookies_accepted() ) {
			$scripts = html_entity_decode( trim( wp_kses( $content, $this->get_allowed_html() ) ) );

			if ( ! empty( $scripts ) ) {
				if ( preg_match_all( '/' . get_shortcode_regex() . '/', $content ) ) {
					$scripts = do_shortcode( $scripts );
				}
				return $scripts;
			}
		}
		return '';
	}

	/**
	 * Register cookies accepted shortcode.
	 *
	 * @param array $args
	 * @param mixed $content
	 * @return mixed
	 */
	public function cookies_revoke_shortcode( $args, $content ) {
		// get options
		$options = $this->options['general'];

		// defaults
		$defaults = array(
			'title' => $options['revoke_text'],
			'class' => $options['css_class']
		);

		// combine shortcode arguments
		$args = shortcode_atts( $defaults, $args );

		// escape class(es)
		$args['class'] = esc_attr( $args['class'] );

		return '<a href="#" class="cn-revoke-cookie cn-button cn-revoke-inline' . ( 'none' !== esc_attr($options['css_style'] ? ' ' . $options['css_style'] : '' ) ) . ( '' !== esc_attr($args['class'] ? ' ' . $args['class'] : '' ) ) . '" title="' . esc_attr( $args['title'] ) . '">' . esc_attr( $args['title'] ) . '</a>';
	}

	/**
	 * Register cookies policy link shortcode.
	 *
	 * @param array $args
	 * @param string $content
	 * @return string
	 */
	public function cookies_policy_link_shortcode( $args, $content ) {
		// active message link position?
		if ( 'yes' === $this->options['general']['see_more'] && 'message' === $this->options['general']['link_position'] ) {
			return '<a href="' . ( 'custom' === $this->options['general']['see_more_opt']['link_type'] ? $this->options['general']['see_more_opt']['link'] : get_permalink( $this->options['general']['see_more_opt']['id'] ) ) . '" target="" id="cn-more-info" class="cn-privacy-policy-link cn-link">' . esc_html( '' !== $this->options['general']['see_more_opt']['text'] ? $this->options['general']['see_more_opt']['text'] : '&#x279c;' ) . '</a>';
		}

		return ' ';
	}

	/**
	 * Register WPML (>= 3.2) strings if needed.
	 *
	 * @return void
	 */
	private function register_wpml_strings() {
		global $wpdb;

		// prepare strings
		$strings = array(
			'Message in the notice' => $this->options['general']['message_text'],
			'Button text' => $this->options['general']['accept_text'],
			'Refuse button text' => $this->options['general']['refuse_text'],
			'Revoke button text' => $this->options['general']['revoke_text'],
			'Privacy policy text' => $this->options['general']['see_more_opt']['text'],
			'Custom link' => $this->options['general']['see_more_opt']['link']
		);

		// get query results
		$results = $wpdb->get_col( $wpdb->prepare( 'SELECT name FROM ' . $wpdb->prefix . 'icl_strings WHERE context = %s', 'Cookie Notice' ) );

		// check results
		foreach ( $strings as $string => $value ) {
			// string does not exist?
			if ( ! in_array( $string, $results, true ) ) {
				// register string
				do_action( 'wpml_register_single_string', 'Cookie Notice', $string, $value );
			}
		}
	}

	/**
	 * Load textdomain.
	 */
	public function load_textdomain() {
		load_plugin_textdomain( 'cookie-notice', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );
	}



	/**
	 * Add submenu.
	 */
	public function admin_menu_options() {
		if ( class_exists( 'WC_Integration' ) ) {			
			add_submenu_page( 'woocommerce', 'GDPR Cookies', 'GDPR Cookies', 'manage_options', 'cookie-notice', array( $this, 'options_page' ) );
		} else {
			add_menu_page( __( 'Cookie Notice', 'cookie-notice' ), __( 'GDPR Cookies', 'cookie-notice' ), apply_filters( 'cn_manage_cookie_notice_cap', 'manage_options' ), 'cookie-notice', array( $this, 'options_page' ) );
		}
		
		
		//add_submenu_page('cookie-notice','Track Users Activities','Track Users Activities','manage_options','track-activities',array( $this, 'track_activitiess') );
	}
	
	/*public function track_activitiess() {
		wp_enqueue_script( 'jq_datatable', plugin_dir_url( __FILE__ ) . 'admin/js/dataTables.min.js', array(), $this->defaults['version'] );
		wp_enqueue_script( 'jq_dtbtn', plugin_dir_url( __FILE__ ) . 'admin/js/dataTables.buttons.min.js', array(), $this->defaults['version'] );
		wp_enqueue_script( 'jq_bthtml', plugin_dir_url( __FILE__ ) . 'admin/js/buttons.html5.min.js', array(), $this->defaults['version'] );
		wp_enqueue_script( 'jq_dtable', plugin_dir_url( __FILE__ ) . 'admin/js/dtable.js', array(), $this->defaults['version'] );
		wp_enqueue_style( 'gdpr_btdatatable', plugins_url( 'css/buttons.dataTables.min.css', __FILE__ ), array(), $this->defaults['version'] );
		wp_enqueue_style( 'gdpr_jqdatatable', plugins_url( 'css/jquery.dataTables.min.css', __FILE__ ), array(), $this->defaults['version'] );
		?>
		
		<style>
		#tracking {
			font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
			border-collapse: collapse;
			width: 100%;
			margin-top:20px;
		}
		</style>
		<?php
		global $wpdb;
		$table_name = $wpdb->prefix . 'track_user_activity';
		$user_gdpr = $wpdb->get_results($wpdb->prepare("SELECT * FROM $table_name "));
		
		echo '<table id="tracking" class="display nowrap" style="width:100%">
			 <thead>
					<tr>
						<th>Id</th>
						<th>Cookie Id</th>
						<th>Email</th>
						<th>Page Url</th>
					</tr>
			 </thead>
			 <tbody>';
		foreach ($user_gdpr as $udata) {
			
			echo '<tr>
					 <td>' . $udata->id . '</td>
					 <td>' . $udata->cookie_id . '</td>
					 <td>' . $udata->user_email . '</td>
					 <td>' . $udata->page_url . '</td>
				 </tr>';
		}
				echo '</tbody> 
			</table>';
		
		
		
	}*/

	
	

	/**
	 * Options page output.
	 * 
	 * @return mixed
	 */
	public function options_page() {
		
		echo '
<form action="options.php" method="post" enctype="multipart/form-data">';

		settings_fields( 'cookie_notice_options' );
		do_settings_sections( 'cookie_notice_options' );
		
		echo '
<p class="submit">';
		submit_button( '', 'primary', 'save_cookie_notice_options', false );
		echo ' ';
		submit_button( __( 'Reset to defaults', 'cookie-notice' ), 'secondary', 'reset_cookie_notice_options', false );
		echo '
</p>
</form>
</div>
<div class="clear"></div>
</div>';
	}

	/**
	 * Regiseter plugin settings.
	 */
	public function register_settings() {
		register_setting( 'cookie_notice_options', 'cookie_notice_options', array( $this, 'validate_options' ) );

		// configuration
		add_settings_section( 'cookie_notice_configuration', __( 'Configuration', 'cookie-notice' ), array( $this, 'cn_section_configuration' ), 'cookie_notice_options' );

		add_settings_field( 'cn_message_text', __( 'Message', 'cookie-notice' ), array( $this, 'cn_message_text' ), 'cookie_notice_options', 'cookie_notice_configuration' );

		add_settings_field( 'cn_accept_text', __( 'Button text', 'cookie-notice' ), array( $this, 'cn_accept_text' ), 'cookie_notice_options', 'cookie_notice_configuration' );

		add_settings_field( 'cn_see_more', __( 'Privacy policy', 'cookie-notice' ), array( $this, 'cn_see_more' ), 'cookie_notice_options', 'cookie_notice_configuration' );
		
		add_settings_field( 'cn_refuse_opt', __( 'Refuse cookies', 'cookie-notice' ), array( $this, 'cn_refuse_opt' ), 'cookie_notice_options', 'cookie_notice_configuration' );
		
		//add_settings_field( 'cn_revoke_opt', __( 'Revoke cookies', 'cookie-notice' ), array( $this, 'cn_revoke_opt' ), 'cookie_notice_options', 'cookie_notice_configuration' );
		
		//add_settings_field( 'cn_refuse_code', __( 'Script blocking', 'cookie-notice' ), array( $this, 'cn_refuse_code' ), 'cookie_notice_options', 'cookie_notice_configuration' );
		
		add_settings_field( 'cn_redirection', __( 'Reloading', 'cookie-notice' ), array( $this, 'cn_redirection' ), 'cookie_notice_options', 'cookie_notice_configuration' );
		add_settings_field( 'cn_on_scroll', __( 'On scroll', 'cookie-notice' ), array( $this, 'cn_on_scroll' ), 'cookie_notice_options', 'cookie_notice_configuration' );
		add_settings_field( 'cn_time', __( 'Cookie expiry', 'cookie-notice' ), array( $this, 'cn_time' ), 'cookie_notice_options', 'cookie_notice_configuration' );
		add_settings_field( 'cn_script_placement', __( 'Script placement', 'cookie-notice' ), array( $this, 'cn_script_placement' ), 'cookie_notice_options', 'cookie_notice_configuration' );
		add_settings_field( 'cn_deactivation_delete', __( 'Deactivation', 'cookie-notice' ), array( $this, 'cn_deactivation_delete' ), 'cookie_notice_options', 'cookie_notice_configuration' );

		// design
		add_settings_section( 'cookie_notice_design', __( 'Design', 'cookie-notice' ), array( $this, 'cn_section_design' ), 'cookie_notice_options' );
		add_settings_field( 'cn_position', __( 'Position', 'cookie-notice' ), array( $this, 'cn_position' ), 'cookie_notice_options', 'cookie_notice_design' );
		add_settings_field( 'cn_hide_effect', __( 'Animation', 'cookie-notice' ), array( $this, 'cn_hide_effect' ), 'cookie_notice_options', 'cookie_notice_design' );
		add_settings_field( 'cn_css_style', __( 'Button style', 'cookie-notice' ), array( $this, 'cn_css_style' ), 'cookie_notice_options', 'cookie_notice_design' );
		add_settings_field( 'cn_css_class', __( 'Button class', 'cookie-notice' ), array( $this, 'cn_css_class' ), 'cookie_notice_options', 'cookie_notice_design' );

		add_settings_field( 'cn_colors', __( 'Colors', 'cookie-notice' ), array( $this, 'cn_colors' ), 'cookie_notice_options', 'cookie_notice_design' );

		add_settings_field('cookie_count', __('Count Of Users Accepted', 'cookoie-notice'), array($this,'accepted_coookie_count'), 'cookie_notice_options', 'cookie_notice_design'); 
		
		
		/*add_settings_field( 'add_europe_countries', __( 'Add European Countries', 'cookie-notice' ), array( $this, 'add_europe_countries' ), 'cookie_notice_options', 'cookie_notice_design' );
		
		add_settings_field( 'ignore_geolocation', __( 'Ignore Geo Location', 'cookie-notice' ), array( $this, 'ignore_geolocation' ), 'cookie_notice_options', 'cookie_notice_design' );*/
		
		add_settings_field('location_setting', __('Location Setting', 'cookoie-notice'), array($this,'location_setting'), 'cookie_notice_options', 'cookie_notice_design');

		add_settings_field('geo_location_select_country', __('Geo Location Countries', 'cookoie-notice'), array($this,'geo_location_select_country'), 'cookie_notice_options', 'cookie_notice_design');

		add_settings_field('Import_cookie', __('Export Cookies', 'cookoie-notice'), array($this,'import_cookie'), 'cookie_notice_options', 'cookie_notice_design');
		
		add_settings_field('Track_user_activaty', __('Track Users Activities', 'cookoie-notice'), array($this,'track_user'), 'cookie_notice_options', 'cookie_notice_design');

		add_settings_field( 'google_analytics', __( 'Google Analytics', 'cookie-notice' ), array( $this, 'cn_google_analytics' ), 'cookie_notice_options', 'cookie_notice_configuration' );

		add_settings_field( 'google_analytics_tracking_code', __( 'GA Tracking Code', 'cookie-notice' ), array( $this, 'cn_google_analytics_tracking_code' ), 'cookie_notice_options', 'cookie_notice_configuration' );

		/*add_settings_field( 'google_adwords', __( 'Google Adwords', 'cookie-notice' ), array( $this, 'cn_google_ads_enable_disable' ), 'cookie_notice_options', 'cookie_notice_configuration' );

		add_settings_field( 'google_ads_tracking_code', __( 'Google Adwords Script', 'cookie-notice' ), array( $this, 'cn_google_ads_script' ), 'cookie_notice_options', 'cookie_notice_configuration' );*/
	}

	/**
	 * Section callback: fix for WP < 3.3
	 */
	public function cn_section_configuration() {}
	public function cn_section_design() {}

	/**
	 * Delete plugin data on deactivation.
	 */
	public function cn_deactivation_delete() {
		echo '
<fieldset>
<label><input id="cn_deactivation_delete" type="checkbox" name="cookie_notice_options[deactivation_delete]" value="1" ' . checked( 'yes', $this->options['general']['deactivation_delete'], false ) . '/> Enable if you would like all plugin data to be deleted if plugin is deactivated.</label>
</fieldset>';
	}

	/**
	 * Cookie message option.
	 */
	public function cn_message_text() {
		echo '
<fieldset>
<div id="cn_message_text">
<textarea name="cookie_notice_options[message_text]" class="large-text" cols="50" rows="5">' . esc_textarea( $this->options['general']['message_text'] ) . '</textarea>
<p class="description">' . sprintf(__( 'Enter the text of the GDPR cookie notice displayed to site visitors.', 'cookie-notice' )) . '</p>
</div>
</fieldset>';
	}

	/**
	 * Accept cookie label option.
	 */
	public function cn_accept_text() {
		echo '
<fieldset>
<div id="cn_accept_text">
<input type="text" class="regular-text" name="cookie_notice_options[accept_text]" value="' . esc_attr( $this->options['general']['accept_text'] ) . '" />
<p class="description">' . sprintf(__( 'Enter the text of the option to accept cookies.', 'cookie-notice' )) . '</p>
</div>
</fieldset>';
	}

	/**
	 * Enable/Disable third party non functional cookies option.
	 */
	public function cn_refuse_opt() {
		echo '
<fieldset>
<label><input id="cn_refuse_opt" type="checkbox" name="cookie_notice_options[refuse_opt]" value="1" ' . checked( 'yes', $this->options['general']['refuse_opt'], false ) . ' />' . sprintf(__( 'Enable if you wish to give site vistors to option to refuse cookies.', 'cookie-notice' )) . '</label>
<div id="cn_refuse_opt_container"' . ( 'no' === $this->options['general']['refuse_opt'] ? ' style="display: none;"' : '' ) . '>
<div id="cn_refuse_text">
<input type="text" class="regular-text" name="cookie_notice_options[refuse_text]" value="' . esc_attr( $this->options['general']['refuse_text'] ) . '" />
<p class="description">' . sprintf(__( 'Text displayed on the button that visitors click to refuse cookies.', 'cookie-notice' )) . '</p>
</div>
</div>
</fieldset>';
	}

	/**
	 * Non functional cookies code.
	 */
	public function cn_refuse_code() {
		$allowed_html = $this->get_allowed_html();
		$active = ! empty( $this->options['general']['refuse_code'] ) && empty( $this->options['general']['refuse_code_head'] ) ? 'body' : 'head';

		echo '
<fieldset>
<div id="cn_refuse_code">
<div id="cn_refuse_code_fields">
<h2 class="nav-tab-wrapper">
<a id="refuse_head-tab" class="nav-tab' . ( 'head' === $active ? ' nav-tab-active' : '' ) . '" href="#refuse_head">' . sprintf(__( 'Head', 'cookie-notice' )) . '</a>
<a id="refuse_body-tab" class="nav-tab' . ( 'body' === $active ? ' nav-tab-active' : '' ) . '" href="#refuse_body">' . sprintf(__( 'Body', 'cookie-notice' )) . '</a>
</h2>
<div id="refuse_head" class="refuse-code-tab' . ( 'head' === $active ? ' active' : '' ) . '">
<p class="description">' . sprintf(__( 'The code to be used in your site header, before the closing head tag.', 'cookie-notice' )) . '</p>
<textarea name="cookie_notice_options[refuse_code_head]" class="large-text" cols="50" rows="8">' . esc_textarea( trim( wp_kses( $this->options['general']['refuse_code_head'], $allowed_html ) ) ) . '</textarea>
</div>
<div id="refuse_body" class="refuse-code-tab' . ( 'body' === $active ? ' active' : '' ) . '">
<p class="description">' . sprintf(__( 'The code to be used in your site footer, before the closing body tag.', 'cookie-notice' )) . '</p>
<textarea name="cookie_notice_options[refuse_code]" class="large-text" cols="50" rows="8">' . esc_textarea( trim( wp_kses( $this->options['general']['refuse_code'], $allowed_html ) ) ) . '</textarea>
</div>
</div>
<p class="description">' . sprintf(__( 'Enter non functional cookies Javascript code here (for e.g. Google Analytics) to be used after cookies are accepted.', 'cookie-notice' )) . '</br>' . sprintf(__( 'To get the cookie notice status use <code>cn_cookies_accepted()</code> function.', 'cookie-notice' )) . '</p>
</div>
</fieldset>';
	}

	/**
	 * Revoke cookies option.
	 */
	public function cn_revoke_opt() {
		echo '
<fieldset>
<label><input id="cn_revoke_cookies" type="checkbox" name="cookie_notice_options[revoke_cookies]" value="1" ' . checked( true, $this->options['general']['revoke_cookies'], false ) . ' />' . sprintf(__( 'Enable to give to the user the possibility to revoke their cookie consent <i>(requires "Refuse cookies" option enabled)</i>.', 'cookie-notice' )) . '</label>
<div id="cn_revoke_opt_container"' . ( $this->options['general']['revoke_cookies'] ? '' : ' style="display: none;"' ) . '>
<input type="text" class="regular-text" name="cookie_notice_options[revoke_text]" value="' . esc_attr( $this->options['general']['revoke_text'] ) . '" />
<p class="description">' . sprintf(__( 'Text displayed on the button for visitors to revoke consent to use cookies.', 'cookie-notice' )) . '</p>';

		foreach ( $this->revoke_opts as $value => $label ) {
			echo '
<label><input id="cn_revoke_cookies-' . esc_attr($value) . '" type="radio" name="cookie_notice_options[revoke_cookies_opt]" value="' . esc_attr($value) . '" ' . checked( $value, $this->options['general']['revoke_cookies_opt'], false ) . ' />' . esc_html( $label ) . '</label>';
		}

		echo '
<p class="description">' . sprintf(__( 'Select the method for displaying the revoke button - automatic (in the Cookie Notice container) or manual using <code>[cookies_revoke]</code> shortcode.', 'cookie-notice' )) . '</p>
</div>
</fieldset>';
	}

	/**
	 * Redirection on cookie accept.
	 */
	public function cn_redirection() {
		echo '
<fieldset>
<label><input id="cn_redirection" type="checkbox" name="cookie_notice_options[redirection]" value="1" ' . checked( true, $this->options['general']['redirection'], false ) . ' />' . sprintf(__( 'Enable to reload the page after cookies are accepted.', 'cookie-notice' )) . '</label>
</fieldset>';
		?>
		<script type="text/javascript">
			$(document).ready(function(){
				$("#cn_redirection").change(function(){
					if($("#cn_on_scroll").prop("checked") == true){
						$("#cn_on_scroll").prop('checked', false);
						$("#cn_redirection").prop('checked', true); 
					}
				});

			});
		</script> 
		<?php
	}

	/**
	 * Privacy policy link option.
	 */
	public function cn_see_more() {
		$pages = get_pages(
			array(
				'sort_order' => 'ASC',
				'sort_column' => 'post_title',
				'hierarchical' => 0,
				'child_of' => 0,
				'parent' => -1,
				'offset' => 0,
				'post_type' => 'page',
				'post_status' => 'publish'
			)
		);

		echo '
<fieldset>
<label><input id="cn_see_more" type="checkbox" name="cookie_notice_options[see_more]" value="1" ' . checked( 'yes', $this->options['general']['see_more'], false ) . ' />' . sprintf(__( 'Enable privacy policy link.', 'cookie-notice' )) . '</label>
<div id="cn_see_more_opt"' . ( 'no' === $this->options['general']['see_more'] ? ' style="display: none;"' : '' ) . '>
<input type="text" class="regular-text" name="cookie_notice_options[see_more_opt][text]" value="' . esc_attr( $this->options['general']['see_more_opt']['text'] ) . '" />
<p class="description">' . sprintf(__( 'Text displayed on the privacy policy button.', 'cookie-notice' )) . '</p>
<div id="cn_see_more_opt_custom_link">';

		foreach ( $this->links as $value => $label ) {
			$value = esc_attr( $value );

			echo '
<label><input id="cn_see_more_link-' . esc_attr($value) . '" type="radio" name="cookie_notice_options[see_more_opt][link_type]" value="' . esc_attr($value) . '" ' . checked( $value, $this->options['general']['see_more_opt']['link_type'], false ) . ' />' . esc_html( $label ) . '</label>';
		}

		echo '
</div>
<p class="description">' . sprintf(__( 'Select where to redirect user for more information about cookies.', 'cookie-notice' )) . '</p>
<div id="cn_see_more_opt_page"' . ( 'custom' === $this->options['general']['see_more_opt']['link_type'] ? ' style="display: none;"' : '' ) . '>
<select name="cookie_notice_options[see_more_opt][id]">
<option value="empty" ' . selected( 'empty', $this->options['general']['see_more_opt']['id'], false ) . '>' . sprintf(__( '-- select page --', 'cookie-notice' )) . '</option>';

		if ( $pages ) {
			foreach ( $pages as $page ) {
				echo '
<option value="' . esc_attr($page->ID) . '" ' . selected( $page->ID, $this->options['general']['see_more_opt']['id'], false ) . '>' . esc_html( $page->post_title ) . '</option>';
			}
		}

		echo '
</select>
<p class="description">' . sprintf(__( 'Select from one of your site\'s pages.', 'cookie-notice' )) . '</p>';

		global $wp_version;

		

		echo '
</div>
<div id="cn_see_more_opt_link"' . ( 'page' === $this->options['general']['see_more_opt']['link_type'] ? ' style="display: none;"' : '' ) . '>
<input type="text" class="regular-text" name="cookie_notice_options[see_more_opt][link]" value="' . esc_attr( $this->options['general']['see_more_opt']['link'] ) . '" />
<p class="description">' . sprintf(__( 'Enter the full URL starting with http(s)://', 'cookie-notice' )) . '</p>
</div>
<div id="cn_see_more_link_target">';

		foreach ( $this->link_targets as $key => $target ) {
			echo '
<label><input id="cn_see_more_link_target-' . esc_attr($key) . '" type="radio" name="cookie_notice_options[link_target]" value="' . esc_attr($key) . '" ' . checked( $key, $this->options['general']['link_target'], false ) . ' />' . esc_html($target) . '</label>';
		}

		echo '
<p class="description">' . esc_html__( 'Select the privacy policy link target.', 'cookie-notice' ) . '</p>
</div>
<div id="cn_see_more_link_position">';

		foreach ( $this->link_positions as $position => $label ) {
			echo '
<label><input id="cn_see_more_link_position-' . esc_attr($position) . '" type="radio" name="cookie_notice_options[link_position]" value="' . esc_attr($position) . '" ' . checked( $position, $this->options['general']['link_position'], false ) . ' />' . esc_html( $label ) . '</label>';
		}

		echo '
<p class="description">' . esc_html__( 'Select the privacy policy link position.', 'cookie-notice' ) . '</p>
</div></div>
</fieldset>';
	}

	/**
	 * Expiration time option.
	 */
	public function cn_time() {
		echo '
<fieldset>
<div id="cn_time">
<select name="cookie_notice_options[time]">';

		foreach ( $this->times as $time => $arr ) {
			$time = esc_attr( $time );

			echo '
<option value="' . esc_attr($time) . '" ' . selected( $time, $this->options['general']['time'] ) . '>' . esc_html( $arr[0] ) . '</option>';
		}

		echo '
</select>
<p class="description">' . sprintf(__( 'Time until cookies expire.', 'cookie-notice' )) . '</p>
</div>
</fieldset>';
	}

	/**
	 * Script placement option.
	 */
	public function cn_script_placement() {
		echo '
<fieldset>';

		foreach ( $this->script_placements as $value => $label ) {
			echo '
<label><input id="cn_script_placement-' . esc_attr($value) . '" type="radio" name="cookie_notice_options[script_placement]" value="' . esc_attr( $value ) . '" ' . checked( $value, $this->options['general']['script_placement'], false ) . ' />' . esc_html( $label ) . '</label>';
		}

		echo '
<p class="description">' . sprintf(__( 'Select where all the plugin scripts should be placed.', 'cookie-notice' )) . '</p>
</fieldset>';
	}

	/**
	 * Position option.
	 */
	public function cn_position() {
		echo '
<fieldset>
<div id="cn_position">';

		foreach ( $this->positions as $value => $label ) {
			$value = esc_attr( $value );

			echo '
<label><input id="cn_position-' . esc_attr($value) . '" type="radio" name="cookie_notice_options[position]" value="' . esc_attr($value) . '" ' . checked( $value, $this->options['general']['position'], false ) . ' />' . esc_html( $label ) . '</label>';
		}

		echo '
<p class="description">' . sprintf(__( 'Select location on screen for your cookie notice.', 'cookie-notice' )) . '</p>
</div>
</fieldset>';
	}

	/**
	 * Animation effect option.
	 */
	public function cn_hide_effect() {
		echo '
<fieldset>
<div id="cn_hide_effect">';

		foreach ( $this->effects as $value => $label ) {
			$value = esc_attr( $value );

			echo '
<label><input id="cn_hide_effect-' . esc_attr($value) . '" type="radio" name="cookie_notice_options[hide_effect]" value="' . esc_attr($value) . '" ' . checked( $value, $this->options['general']['hide_effect'], false ) . ' />' . esc_html( $label ) . '</label>';
		}

		echo '
<p class="description">' . sprintf(__( 'Cookie notice acceptance animation.', 'cookie-notice' )) . '</p>
</div>
</fieldset>';
	}

	/**
	 * On scroll option.
	 */
	public function cn_on_scroll() {
		echo '
<fieldset>
<label><input id="cn_on_scroll" type="checkbox" name="cookie_notice_options[on_scroll]" value="1" ' . checked( 'yes', $this->options['general']['on_scroll'], false ) . ' />' . sprintf(__( 'Enable automatic cookie acceptance when users scroll.', 'cookie-notice' )) . '</label>
<div id="cn_on_scroll_offset"' . ( 'no' === $this->options['general']['on_scroll'] || false === $this->options['general']['on_scroll'] ? ' style="display: none;"' : '' ) . '>
<input type="text" class="text" name="cookie_notice_options[on_scroll_offset]" value="' . esc_attr( $this->options['general']['on_scroll_offset'] ) . '" /> <span>px</span>
<p class="description">' . sprintf(__( 'Number of pixels user has to scroll to implicitly accept cookies and make the notification disappear.', 'cookie-notice' )) . '</p>
</div>
</fieldset>';
		?>
		<script type="text/javascript">
			$(document).ready(function(){
				$("#cn_on_scroll").change(function(){
					if($("#cn_redirection").prop("checked") == true){
						$("#cn_redirection").prop('checked', false);
						$("#cn_on_scroll").prop('checked', true); 
					}
				});
			});
		</script>
		<?php
	}

	/**
	 * CSS style option.
	 */
	public function cn_css_style() {
		echo '
<fieldset>
<div id="cn_css_style">';

		foreach ( $this->styles as $value => $label ) {
			$value = esc_attr( $value );

			echo '
				<label><input id="cn_css_style-' . esc_attr($value) . '" type="radio" name="cookie_notice_options[css_style]" value="' . esc_attr($value) . '" ' . checked( $value, $this->options['general']['css_style'], false ) . ' />' . esc_html( $label ) . '</label>';
		}

		echo '
				<p class="description">' . sprintf(__( 'Choose button style.', 'cookie-notice' )) . '</p>
</div>
</fieldset>';
	}

	/**
	 * CSS style option.
	 */
	public function cn_css_class() {
		echo '
<fieldset>
<div id="cn_css_class">
<input type="text" class="regular-text" name="cookie_notice_options[css_class]" value="' . esc_attr( $this->options['general']['css_class'] ) . '" />
<p class="description">' . sprintf(__( 'Enter additional button CSS classes separated by spaces.', 'cookie-notice' )) . '</p>
</div>
</fieldset>';
	}

	/**
	 * Colors option.
	 */
	public function cn_colors() {
		echo '
		<fieldset>';
		
		foreach ( $this->colors as $value => $label ) {
			$value = $value ;

			echo '
			<div id="cn_colors-' . esc_attr($value) . '"><label>' . esc_html( $label ) . '</label><br />
				<input class="cn_color" type="text" name="cookie_notice_options[colors][' . esc_attr($value) . ']" value="' . esc_attr($this->options['general']['colors'][$value]) . '" />' .
			'</div>';
		}
		
		echo '
		</fieldset>';
	}

	/**
	 *
	 * Count of accepted cookies.
	 *
	 */
	public function accepted_coookie_count() {
		$count = get_option('accepted_cookie_count');
		echo '
		<fieldset>';
		echo '
			<div id="cn_cookie_count"><label>Count of Users who Accept Cookies</label><br />
				<input class="cn_cookie_count" type="text" name="count" value="' . esc_attr($count) . '" readonly />' .
			'</div>';
		echo '
		</fieldset>';
	}
	/**
	*
	* Geo Location Select Country Fieldset
	*
	*/

	public function wpdocs_selectively_enqueue_admin_script( $hook ) {
		
		if ( 'toplevel_page_cookie-notice' !== $hook && 'woocommerce_page_cookie-notice' !== $hook ) {
			return;
		}
		wp_enqueue_script( 'my_custom_script', plugin_dir_url( __FILE__ ) . 'admin/js/jquerymin.js', array(), $this->defaults['version'] );
		wp_enqueue_script( 'select2', plugin_dir_url( __FILE__ ) . 'admin/js/select2.js', array(), $this->defaults['version'] );
		wp_enqueue_script( 'adsbygoogle', plugin_dir_url( __FILE__ ) . 'admin/js/adsbygoogle.js', array(), $this->defaults['version'] );		
	}
	
	/*
	* geo location select all european country
	*/

	/*public function add_europe_countries() {
		$check_option = get_option('european_countries');
		?>
		<fieldset>
			<label><input id="add_europe_countries" type="checkbox" name="cookie_notice_options[european_countries]" value="1" 
			<?php 
			if ( '1' == $check_option ) { || 'woocommerce_page_cookie-notice' !== $hook
				echo'checked';
			}
			?>
				>
		 Enable to select all european Countries.</label>
		</fieldset>
		<?php
	}*/
	
	/*
	* ignore geo location and select all countries
	*/
	/*public function ignore_geolocation() {
		$check_option = get_option('ignore_geolocation');
		?>
		<fieldset>
			<label><input id="ignore_geolocation" type="checkbox" name="cookie_notice_options[ignore_geolocation]" value="1" 
			<?php 
			if ( '1' == $check_option ) { 
				echo'checked';
			}
			?>
				>
		 Enable to select all Countries.</label>
		</fieldset>
		<?php
	}*/
	
	/*
	* Location Setting
	*/
	public function location_setting() {
		
		echo '<fieldset>
<div id="location_setting">
<select id="location-select" name="cookie_notice_options[location_setting]">';
			
		foreach ( $this->locationsetting as $time => $arr ) {
			$time = esc_attr( $time );	
			?>
			
			<option value="<?php echo esc_attr($time); ?>" 
									 <?php 
										$res = isset($this->options['general']['location_setting']) ? $this->options['general']['location_setting'] : '';
										if (!empty($res)) {
											if ($res == $time) {
												echo "selected='selected'";
											} else {
												echo ''; } } 
										?>
			 ><?php echo esc_html( $arr ); ?></option>
			<?php 
		}

		echo '</select>
</div>
</fieldset>';
	}
	
	/*
	* geo location select country
	*/
	public function geo_location_select_country() {
		wp_enqueue_style( 'select2', plugins_url( 'css/select2.css', __FILE__ ), array(), '1.0' );
	
	
		?>
		
	<script type="text/javascript">
		
		$(function(){
			$('#slct').select2({
				placeholder:"Select Country",
			});
		});
	</script>
		<?php
		echo '<fieldset>
		<div id="cn_country">
		<select name="cookie_notice_options[country][]" multiple id="slct" style="width:350px">';
		for ( $i=0; $i<=count($this->countryList); $i++ ) {
			if ( isset($this->countryList[$i]) ) {
				?>
				<option value="<?php echo esc_attr($this->countryList[$i]); ?>" 
				<?php 
				$res = get_option('geo_country_list');
				if ( !empty($res) ) {
					if (in_array($this->countryList[$i], $res)) {
						echo "selected='selected'";
					} else {
						echo ''; 
					} 
				} 
				?>
				> <?php echo esc_attr($this->countryList[$i]); ?>
				</option>
				<?php 
			}
		}
		echo '</select>
		</div>
		</fieldset>';

	}
	/*
	* Import cookies
	*/

	public function import_cookie() {

		echo '
		<fieldset>
			<div id="import_cookies">
			<a href="' . esc_url ( plugins_url('/download_able.php', __FILE__ ) ) . '"><button type="button" id="btn_id">Export</button></a>
			<div>
		</fieldset>';

	}

	public function track_user() { 

		echo '
		<fieldset> 
		<div id="track_cookies">
		<a href="' . esc_url ( plugins_url('/download_track_user.php', __FILE__ ) ) . '"><button type="button" id="btn_id">Track Users Activities</button></a>

		<div>
		</fieldset>';

	}

	public function track_user_activity_txt_file() {
		global $wpdb;
		$table_name = $wpdb->prefix . 'track_user_activity';
		$user_gdpr = $wpdb->get_results('SELECT * FROM ' . $wpdb->prefix . 'track_user_activity');
		$track_info = json_encode($user_gdpr);
		file_put_contents(dirname(__FILE__) . '/track_user_info.txt', $track_info);
	}

	/*
	 * create txt file
	 */

	public function create_txt_file() {
		global $wpdb;
		$table_name = $wpdb->prefix . 'cookie_info';
		$user_gdpr = $wpdb->get_results('SELECT * FROM ' . $wpdb->prefix . 'cookie_info');
		$datas = json_encode($user_gdpr);
		file_put_contents(dirname(__FILE__) . '/cookie_info_data.txt', $datas);
	}

	
	/*
	* Google analytics custom field
	*/
	public function cn_google_analytics() {
		$check_option = get_option('enable_disable_ga');
		?>
		<fieldset>
			<label><input id="cn_google_analytics" type="checkbox" name="cookie_notice_options[analytics]" value="1" 
			<?php 
			if ( '1' == $check_option ) { 
				echo'checked';
			}
			?>
				>
		 Enable to allow track via google analytics.</label>
		</fieldset>
		<?php
	}

	/*
	* Google Analytics script
	*/
	public function gdpr_google_analytics() {
		$tracking_id = get_option('GA_tracking_id');
		$enable_disable_ga = get_option('enable_disable_ga');
		if ( '1' == $enable_disable_ga ) {
			//echo $enable_disable_ga; die;
			wp_enqueue_script('google-tagmanager', 'https://www.googletagmanager.com/gtag/js?&id=' . esc_attr($tracking_id), array(), true);
			?>
			<script>
			 window.dataLayer = window.dataLayer || [];
			 function gtag(){dataLayer.push(arguments);}
			 gtag('js', new Date());

			 gtag('config', '<?php echo esc_attr ( $tracking_id ); ?>');
			</script>
			<?php
		}
	}

	/*
	* google analytics tracking field
	*/
	public function cn_google_analytics_tracking_code() {
		$tracking_id = get_option('GA_tracking_id');
		echo '
		<fieldset>
		<input id="cn_google_analytics_tracking_id" type="text" name="cookie_notice_options[tracking_id]" value="' . esc_attr($tracking_id) . '" /><br/> <label>' . sprintf(__( 'Enter Google Analytics Tracking Code Here.', 'cookie-notice' )) . '</label>
		</fieldset>';
	}

	/*
	* Google adsense custom field
	*/
	/*public function cn_google_ads_enable_disable() {
		?>
		<fieldset>
			<label><input id="cn_google_ads" type="checkbox" name="cookie_notice_options[ads]" value="1">
		 Enable to allow google adwords.</label>
		</fieldset>
		<?php
	}*/

	/*public function cn_google_ads_script(){
	echo '
		<fieldset>
			<div id="cn_ads_script">
				<textarea name="cookie_notice_options[ads_Script]" class="large-text" cols="50" rows="5"></textarea>
				<p class="description">' . sprintf(__( 'Enter the google ads script.', 'cookie-notice' )) . '</p>
			</div>
		</fieldset>';
	}*/
	/*
	 * Google adwords
	*/
	public function cn_google_adwords() { 

		echo '<script>
		(adsbygoogle = window.adsbygoogle || []).push({
		google_ad_client: "ca-pub-8620930463646356",
		enable_page_level_ads: true
		});
		</script>';
	}

	/**
	 * Validate options.
	 * 
	 * @param array $input
	 * @return array
	 */
	public function validate_options( $input ) {
		$_wpnonce = isset( $_POST['_wpnonce'] ) ? sanitize_text_field( $_POST['_wpnonce'] ) : ''; 
		wp_verify_nonce( !empty( sanitize_text_field( $_wpnonce ) ) );

		if ( ! current_user_can( apply_filters( 'cn_manage_cookie_notice_cap', 'manage_options' ) ) ) {
			return $input;
		}

		if ( isset( $_POST['save_cookie_notice_options'] ) ) {
			/* echo '<pre>';
			print_r($_POST);
			echo '</pre>';
			die; */
			// position
			$input['position'] = sanitize_text_field( isset( $input['position'] ) && in_array( $input['position'], array_keys( $this->positions ) ) ? $input['position'] : $this->defaults['general']['position'] );

			// colors
			$input['colors']['text'] = sanitize_text_field($input['colors']['text']); //sanitize_text_field( isset( $input['colors']['text'] ) && $input['colors']['text'] !== '' && preg_match( '/^#[a-f0-9]{6}$/', $input['colors']['text'] ) === 1 ? $input['colors']['text'] : $this->defaults['general']['colors']['text'] );

			$input['colors']['bar'] = sanitize_text_field($input['colors']['bar']); //sanitize_text_field( isset( $input['colors']['bar'] ) && $input['colors']['bar'] !== '' && preg_match( '/^#[a-f0-9]{6}$/', $input['colors']['bar'] ) === 1 ? $input['colors']['bar'] : $this->defaults['general']['colors']['bar'] );

			// texts
			$input['message_text'] = wp_kses_post( isset( $input['message_text'] ) && '' !== $input['message_text'] ? $input['message_text'] : $this->defaults['general']['message_text'] );
			$input['accept_text'] = sanitize_text_field( isset( $input['accept_text'] ) && '' !== $input['accept_text'] ? $input['accept_text'] : $this->defaults['general']['accept_text'] );
			$input['refuse_text'] = sanitize_text_field( isset( $input['refuse_text'] ) && '' !== $input['refuse_text'] ? $input['refuse_text'] : $this->defaults['general']['refuse_text'] );
			$input['revoke_text'] = sanitize_text_field( isset( $input['revoke_text'] ) && '' !== $input['revoke_text'] ? $input['revoke_text'] : $this->defaults['general']['revoke_text'] );
			$input['refuse_opt'] = (bool) isset( $input['refuse_opt'] ) ? 'yes' : 'no';
			$input['revoke_cookies'] = isset( $input['revoke_cookies'] );
			$input['revoke_cookies_opt'] = isset( $input['revoke_cookies_opt'] ) && array_key_exists( $input['revoke_cookies_opt'], $this->revoke_opts ) ? $input['revoke_cookies_opt'] : $this->defaults['general']['revoke_cookies_opt'];

			// get allowed HTML
			$allowed_html = $this->get_allowed_html();

			// body refuse code
			$input['refuse_code'] = wp_kses( isset( $input['refuse_code'] ) && '' !== $input['refuse_code'] ? $input['refuse_code'] : $this->defaults['general']['refuse_code'], $allowed_html );

			// head refuse code
			$input['refuse_code_head'] = wp_kses( isset( $input['refuse_code_head'] ) && '' !== $input['refuse_code_head'] ? $input['refuse_code_head'] : $this->defaults['general']['refuse_code_head'], $allowed_html );

			// css button style
			$input['css_style'] = sanitize_text_field( isset( $input['css_style'] ) && in_array( $input['css_style'], array_keys( $this->styles ) ) ? $input['css_style'] : $this->defaults['general']['css_style'] );

			// css button class
			$input['css_class'] = sanitize_text_field( isset( $input['css_class'] ) ? $input['css_class'] : $this->defaults['general']['css_class'] );

			// link target
			$input['link_target'] = sanitize_text_field( isset( $input['link_target'] ) && in_array( $input['link_target'], array_keys( $this->link_targets ) ) ? $input['link_target'] : $this->defaults['general']['link_target'] );

			// link target
			$input['link_position'] = sanitize_text_field( isset( $input['link_position'] ) && in_array( $input['link_position'], array_keys( $this->link_positions ) ) ? $input['link_position'] : $this->defaults['general']['link_position'] );

			// message link position?
			if ( 'message' === $input['link_position'] && strpos( $input['message_text'], '[cookies_policy_link]' ) === false ) {
				$input['message_text'] .= ' [cookies_policy_link]';
			}

			// time
			$input['time'] = sanitize_text_field( isset( $input['time'] ) && in_array( $input['time'], array_keys( $this->times ) ) ? $input['time'] : $this->defaults['general']['time'] );

			// script placement
			$input['script_placement'] = sanitize_text_field( isset( $input['script_placement'] ) && in_array( $input['script_placement'], array_keys( $this->script_placements ) ) ? $input['script_placement'] : $this->defaults['general']['script_placement'] );

			// hide effect
			$input['hide_effect'] = sanitize_text_field( isset( $input['hide_effect'] ) && in_array( $input['hide_effect'], array_keys( $this->effects ) ) ? $input['hide_effect'] : $this->defaults['general']['hide_effect'] );
			
			// on scroll
			$input['on_scroll'] = (bool) isset( $input['on_scroll'] ) ? 'yes' : 'no';

			// on scroll
			$input['redirection'] = isset( $input['redirection'] );

			// on scroll offset
			$input['on_scroll_offset'] = absint( isset( $input['on_scroll_offset'] ) && '' !== $input['on_scroll_offset'] ? $input['on_scroll_offset'] : $this->defaults['general']['on_scroll_offset'] );

			// deactivation
			$input['deactivation_delete'] = (bool) isset( $input['deactivation_delete'] ) ? 'yes' : 'no';

			// privacy policy
			$input['see_more'] = (bool) isset( $input['see_more'] ) ? 'yes' : 'no';

			$input['see_more_opt']['text'] = sanitize_text_field( isset( $input['see_more_opt']['text'] ) && '' !== $input['see_more_opt']['text'] ? $input['see_more_opt']['text'] : $this->defaults['general']['see_more_opt']['text'] );
			$input['see_more_opt']['link_type'] = sanitize_text_field( isset( $input['see_more_opt']['link_type'] ) && in_array( $input['see_more_opt']['link_type'], array_keys( $this->links ) ) ? $input['see_more_opt']['link_type'] : $this->defaults['general']['see_more_opt']['link_type'] );

			
			if ( 1 == $input['location_setting'] ) {
				update_option('ignore_geolocation', '');
				update_option('european_countries', isset($input['european_countries']) ? $input['european_countries'] : ''); 
				update_option('geo_country_list', $this->european_countryList); 
			} elseif ( 2 == $input['location_setting'] ) {
				update_option('european_countries', '');
				update_option('ignore_geolocation', isset($input['ignore_geolocation']) ? $input['ignore_geolocation'] : ''); 
				update_option('geo_country_list', $this->countryList); 
			} elseif ( 3 == $input['location_setting'] ) {
				update_option('european_countries', '');
				update_option('ignore_geolocation', '');
				update_option('geo_country_list', isset($input['country']) ? $input['country'] : '');
			} elseif ( 0 == $input['location_setting'] ) {
				update_option('european_countries', '');
				update_option('ignore_geolocation', '');
				update_option('geo_country_list', isset($input['country']) ? $input['country'] : '');
			}
				
			update_option('GA_tracking_id', isset($input['tracking_id']) ? $input['tracking_id'] : '');
			update_option('enable_disable_ga', isset($input['analytics']) ? $input['analytics'] : '');
			update_option('google_ads_script', isset($input['ads_Script']) ? $input['ads_Script'] : '');


			if ( 'custom' === $input['see_more_opt']['link_type'] ) {
				$input['see_more_opt']['link'] = esc_url( $input['see_more'] ? $input['see_more_opt']['link'] : 'empty' );
			} elseif ( 'page' === $input['see_more_opt']['link_type'] ) {
				//$input['see_more_opt']['id'] = ( $input['see_more'] === 'yes' ? (int) $input['see_more_opt']['id'] : 'empty' );
				$input['see_more_opt']['sync'] = isset( $input['see_more_opt']['sync'] );

				if ( $input['see_more_opt']['sync'] ) {
					
					
					update_option( 'wp_page_for_privacy_policy', $input['see_more_opt']['id'] );
				}
			}

			$input['update_version'] = $this->options['general']['update_version'];
			$input['update_notice'] = $this->options['general']['update_notice'];

			$input['translate'] = false;

			// WPML >= 3.2
			if ( defined( 'ICL_SITEPRESS_VERSION' ) && version_compare( ICL_SITEPRESS_VERSION, '3.2', '>=' ) ) {
				do_action( 'wpml_register_single_string', 'Cookie Notice', 'Message in the notice', $input['message_text'] );
				do_action( 'wpml_register_single_string', 'Cookie Notice', 'Button text', $input['accept_text'] );
				do_action( 'wpml_register_single_string', 'Cookie Notice', 'Refuse button text', $input['refuse_text'] );
				do_action( 'wpml_register_single_string', 'Cookie Notice', 'Revoke button text', $input['revoke_text'] );
				do_action( 'wpml_register_single_string', 'Cookie Notice', 'Privacy policy text', $input['see_more_opt']['text'] );

				if ( 'custom' === $input['see_more_opt']['link_type'] ) {
					do_action( 'wpml_register_single_string', 'Cookie Notice', 'Custom link', $input['see_more_opt']['link'] );
				}
			}
		} elseif ( isset( $_POST['reset_cookie_notice_options'] ) ) {
			
			$input = $this->defaults['general'];

			add_settings_error( 'reset_cookie_notice_options', 'reset_cookie_notice_options', __( 'Settings restored to defaults.', 'cookie-notice' ), 'updated' );
			
		}
		 
		return $input;
	}

	/**
	 * Cookie notice output.
	 * 
	 * @return mixed
	 */
	public function add_cookie_notice() {
		
		if ( ! $this->cookies_set() || 'yes' === $this->options['general']['refuse_opt'] ) {
			// WPML >= 3.2
			if ( defined( 'ICL_SITEPRESS_VERSION' ) && version_compare( ICL_SITEPRESS_VERSION, '3.2', '>=' ) ) {
				$this->options['general']['message_text'] = apply_filters( 'wpml_translate_single_string', $this->options['general']['message_text'], 'Cookie Notice', 'Message in the notice' );
				$this->options['general']['accept_text'] = apply_filters( 'wpml_translate_single_string', $this->options['general']['accept_text'], 'Cookie Notice', 'Button text' );
				$this->options['general']['refuse_text'] = apply_filters( 'wpml_translate_single_string', $this->options['general']['refuse_text'], 'Cookie Notice', 'Refuse button text' );
				$this->options['general']['revoke_text'] = apply_filters( 'wpml_translate_single_string', $this->options['general']['revoke_text'], 'Cookie Notice', 'Revoke button text' );
				$this->options['general']['see_more_opt']['text'] = apply_filters( 'wpml_translate_single_string', $this->options['general']['see_more_opt']['text'], 'Cookie Notice', 'Privacy policy text' );
				$this->options['general']['see_more_opt']['link'] = apply_filters( 'wpml_translate_single_string', $this->options['general']['see_more_opt']['link'], 'Cookie Notice', 'Custom link' );
				// WPML and Polylang compatibility
			} elseif ( function_exists( 'icl_t' ) ) {
				$this->options['general']['message_text'] = icl_t( 'Cookie Notice', 'Message in the notice', $this->options['general']['message_text'] );
				$this->options['general']['accept_text'] = icl_t( 'Cookie Notice', 'Button text', $this->options['general']['accept_text'] );
				$this->options['general']['refuse_text'] = icl_t( 'Cookie Notice', 'Refuse button text', $this->options['general']['refuse_text'] );
				$this->options['general']['revoke_text'] = icl_t( 'Cookie Notice', 'Revoke button text', $this->options['general']['revoke_text'] );
				$this->options['general']['see_more_opt']['text'] = icl_t( 'Cookie Notice', 'Privacy policy text', $this->options['general']['see_more_opt']['text'] );
				$this->options['general']['see_more_opt']['link'] = icl_t( 'Cookie Notice', 'Custom link', $this->options['general']['see_more_opt']['link'] );
			}

			if ( function_exists( 'icl_object_id' ) ) {
				$this->options['general']['see_more_opt']['id'] = icl_object_id( $this->options['general']['see_more_opt']['id'], 'page', true );
			}

			// get cookie container args
			$options = apply_filters( 'cn_cookie_notice_args', array(
				'position' => $this->options['general']['position'],
				'css_style' => $this->options['general']['css_style'],
				'css_class' => $this->options['general']['css_class'],
				'button_class' => 'cn-button',
				'colors' => $this->options['general']['colors'],
				'message_text' => $this->options['general']['message_text'],
				'accept_text' => $this->options['general']['accept_text'],
				'refuse_text' => $this->options['general']['refuse_text'],
				'revoke_text' => $this->options['general']['revoke_text'],
				'refuse_opt' => $this->options['general']['refuse_opt'],
				'see_more' => $this->options['general']['see_more'],
				'see_more_opt' => $this->options['general']['see_more_opt'],
				'link_target' => $this->options['general']['link_target'],
				'link_position' => $this->options['general']['link_position'],
				'aria_label' => __( 'Cookie Notice', 'cookie-notice' )
			) );
			$policy_page_id = (int) get_option( 'wp_page_for_privacy_policy' );
			if ( 1 == $options['see_more_opt']['sync']) {
				$policy_link = get_permalink($policy_page_id);
			} else {
				$policy_link = get_permalink($options['see_more_opt']['id']);
			}
			if ( 'yes' === $options['see_more'] && 'message' === $options['link_position'] ) {
				$options['message_text'] = do_shortcode( wp_kses_post( $options['message_text'] ) );
			} else {
				$options['message_text'] = wp_kses_post( $options['message_text'] );
			}

			$options['css_class'] = esc_attr( $options['css_class'] );
			// message output
			$output = '
			<div id="cookie-notice" role="banner" class="cn-' . $options['position'] . ( 'none' !== $options['css_style'] ? ' ' . $options['css_style'] : '' ) . '" style="color: ' . $options['colors']['text'] . '; background-color: ' . $options['colors']['bar'] . ';" aria-label="' . $options['aria_label'] . '">'
				. '<div class="cookie-notice-container"><span id="cn-notice-text">' . $options['message_text'] . '</span>'
				. '<a href="#" id="cn-accept-cookie" data-cookie-set="accept" class="cn-set-cookie ' . $options['button_class'] . ( 'none' !== $options['css_style'] ? ' ' . $options['css_style'] : '' ) . ( '' !== $options['css_class'] ? ' ' . $options['css_class'] : '' ) . '">' . $options['accept_text'] . '</a>'
				. ( 'yes' === $options['refuse_opt'] ? '<a href="#" id="cn-refuse-cookie" data-cookie-set="refuse" class="cn-set-cookie ' . $options['button_class'] . ( 'none' !== $options['css_style'] ? ' ' . $options['css_style'] : '' ) . ( '' !== $options['css_class'] ? ' ' . $options['css_class'] : '' ) . '">' . $options['refuse_text'] . '</a>' : '' )
				. ( 'yes' === $options['see_more'] && 'banner' === $options['link_position'] ? '<a href="' . ( 'custom' === $options['see_more_opt']['link_type'] ? $options['see_more_opt']['link'] : 
					$policy_link ) . '" target="' . $options['link_target'] . '" data-click="' . ( $options['link_target'] ) . '" id="cn-more-info" class="cn-more-info ' . $options['button_class'] . ( 'none' !== $options['css_style'] ? ' ' . $options['css_style'] : '' ) . ( '' !== $options['css_class'] ? ' ' . $options['css_class'] : '' ) . '">' . $options['see_more_opt']['text'] . '</a>' : '' ) . '
		</div>
		' . ( 'yes' === $options['refuse_opt'] ? '<div class="cookie-notice-revoke-container"><a href="#" class="cn-revoke-cookie ' . $options['button_class'] . ( 'none' !== $options['css_style'] ? ' ' . $options['css_style'] : '' ) . ( '' !== $options['css_class'] ? ' ' . $options['css_class'] : '' ) . '">' . esc_html( $options['revoke_text'] ) . '</a></div>' : '' ) . '
		</div>';
			global $wpdb;
			$login_user = get_current_user_id();
			$table_name = $wpdb->prefix . 'usermeta';
			$user_gdpr = $wpdb->get_results($wpdb->prepare('SELECT * FROM ' . $wpdb->prefix . 'usermeta WHERE user_id = %d AND meta_key =%s', $login_user, 'cookie'));
			if ( !empty($user_gdpr) && 'true' == ( isset ( $_COOKIE['opmc_gdpr_accepted'] ) )) {
				echo 'none';

			} else {
				function getVisIPAddr() {

					$client = isset( $_SERVER['HTTP_CLIENT_IP'] ) ? sanitize_text_field( $_SERVER['HTTP_CLIENT_IP'] ) : '' ; 

					$forward = isset( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ? sanitize_text_field( $_SERVER['HTTP_X_FORWARDED_FOR'] ) : ''; 

					$remote = isset( $_SERVER['REMOTE_ADDR'] ) ? sanitize_text_field( $_SERVER['REMOTE_ADDR'] ) : '' ; 

					if ( filter_var($client, FILTER_VALIDATE_IP) ) {
						$ip = $client;
					} elseif ( filter_var($forward, FILTER_VALIDATE_IP) ) {
						$ip = $forward;
					} else {
							$ip = $remote;
					}
						return $ip;
				}
				//echo $_SERVER['REMOTE_ADDR'];
				
				$ip = getVisIPAddr();

				$ipdat = json_decode(file_get_contents('http://www.geoplugin.net/json.gp?ip=' . $ip)); //print_r($ipdat);
				$opmc_gdpr_accepted = isset( $_COOKIE['opmc_gdpr_accepted'] ) ? sanitize_text_field( $_COOKIE['opmc_gdpr_accepted'] ) : '';
				if ( $ipdat && 'true' != $opmc_gdpr_accepted ) { 
					$ipchecker = $ipdat->geoplugin_countryName;
					$res = get_option('geo_country_list');
					if ( !empty( $res ) ) {
						$found = in_array($ipchecker, $res);
						if ($found ) {
							echo wp_kses_post(apply_filters( 'cn_cookie_notice_output', $output, $options ));
						}
					}
				}
			}
		}
	}

	/**
	 * Check if cookies are accepted.
	 * 
	 * @return bool
	 */
	public static function cookies_accepted() {
		return apply_filters( 'cn_is_cookie_accepted', isset( $_COOKIE['opmc_gdpr_accepted'] ) && 'true' === $_COOKIE['opmc_gdpr_accepted'] );
	}
	
	/**
	* Revoke Cookie
	*
	*/
	public function revoke_customer_cookie() {
		global $wpdb;
		$selected_time = get_option('cookie_notice_options');
		if ( 'hour' == $selected_time['time']) {
			$time = 3600;
		}
		if ( 'day' == $selected_time['time']) {
			$time = 86400;
		}
		if ( 'week' == $selected_time['time']) {
			$time = 604800;
		}
		if ( 'month' == $selected_time['time']) {
			$time = 2.628e+6; 
		}
		if ( '3months' == $selected_time['time']) {
			$time = 7.884e+6 ; 
		}
		if ( '6months' == $selected_time['time']) {
			$time = 1.577e+7 ;
		} 
		if ( 'year' == $selected_time['time']) {
			$time = 2.628e+6; 
		}
		
		
		/*unset($_COOKIE['opmc_cookie_accpted']);
		unset($_COOKIE['opmc_cookie_unique_key']);
		unset($_COOKIE['opmc_cookie_user_type']);
		unset($_COOKIE['opmc_gdpr_accepted']);*/
		setcookie( 'opmc_cookie_accpted', '', time()+$time, COOKIEPATH, COOKIE_DOMAIN );
		setcookie( 'opmc_cookie_unique_key', '', time()+$time, COOKIEPATH, COOKIE_DOMAIN );
		setcookie( 'opmc_cookie_user_type', '', time()+$time, COOKIEPATH, COOKIE_DOMAIN );
		setcookie( 'opmc_gdpr_accepted', '', time()+$time, COOKIEPATH, COOKIE_DOMAIN );
		
	}
	
	//add_action('template_redirect', 'user_activity_status');
	public function user_activity_status() {
		global $wpdb;
		if ( 'true' == ( isset ( $_COOKIE['opmc_gdpr_accepted']) ? sanitize_text_field($_COOKIE['opmc_gdpr_accepted']) : 'false' ) ) {
			$login_user = get_current_user_id();
			$get_userdata = get_userdata($login_user);
			if ( 0 != $login_user ) {
				$user_email = $get_userdata->data->user_email;
			} else {
				$user_email = 'Guest User' ;
			}
			$opmc_cookie_unique_key = ( isset($_COOKIE['opmc_cookie_unique_key']) ? sanitize_text_field($_COOKIE['opmc_cookie_unique_key']) : '' );
			$page_url = get_permalink();
			$store_in_table = $wpdb->prefix . 'track_user_activity';
			/*$sql = "INSERT INTO $store_in_table (cookie_id,user_email,page_url) VALUES('$opmc_cookie_unique_key','$user_email','$page_url')";
			$rrr = $wpdb->query($sql); */
			
			$wpdb->query($wpdb->prepare('INSERT INTO ' . $wpdb->prefix . 'track_user_activity (cookie_id, user_email, page_url) VALUES (%s, %s, %s)', array("$opmc_cookie_unique_key", "$user_email", "$page_url")));
			
		}
	}
	
	/**
	*
	* Check custom cookie count
	*
	*/
	
	public function custom_cookie() {
		global $wpdb;
		$login_user = get_current_user_id();
		$get_userdata = get_userdata($login_user);
		if ( 0 != $login_user ) {
			$user_type = 'Logged In User';
			$user_name = $get_userdata->data->display_name;
			$user_email = $get_userdata->data->user_email;
			$user_role = $get_userdata->roles[0];
		} else {
			$user_type = 'Guest User';
			$user_name = 'Guest User';
			$user_email = 'Guest User';
			$user_role = 'Guest User';
		}
			
		$selected_time = get_option('cookie_notice_options');
		if ( 'hour' == $selected_time['time']) {
			$time = 3600;
		}
		if ( 'day' == $selected_time['time']) {
			$time = 86400;
		}
		if ( 'week' == $selected_time['time']) {
			$time = 604800;
		}
		if ( 'month' == $selected_time['time']) {
			$time = 2.628e+6; 
		}
		if ( '3months' == $selected_time['time'] ) {
			$time = 7.884e+6 ; 
		}
		if ( '6months' == $selected_time['time'] ) {
			$time = 1.577e+7 ;
		} 
		if ( 'year' == $selected_time['time'] ) {
			$time = 2.628e+6; 
		}
			
			 $opmc_cookie_accpted = 'true';
			 $opmc_cookie_unique_key = rand();
			 $opmc_cookie_user_type = $user_type;
			 
			setcookie('opmc_cookie_accpted', 'true', time()+$time, COOKIEPATH, COOKIE_DOMAIN);
			setcookie('opmc_cookie_unique_key', $opmc_cookie_unique_key, time()+$time, COOKIEPATH, COOKIE_DOMAIN);
			setcookie('opmc_cookie_user_type', $opmc_cookie_user_type, time()+$time, COOKIEPATH, COOKIE_DOMAIN);
			
				
			$store_in_table = $wpdb->prefix . 'cookie_info';
			

			$wpdb->query($wpdb->prepare('INSERT INTO ' . $wpdb->prefix . 'cookie_info ( user_name, user_email, user_role, opmc_cookie_accpted, opmc_cookie_unique_key, opmc_cookie_user_type ) VALUES (%s, %s, %s, %s, %s, %s)', array("$user_name", "$user_email", "$user_role", "$opmc_cookie_accpted", "$opmc_cookie_unique_key", "$opmc_cookie_user_type")));
			
			
		if (!empty($login_user)) {
			global $wpdb;
			/* $table_name = $wpdb->prefix . "usermeta";
			$insert = $wpdb->get_results($wpdb->prepare(INSERT INTO " $wpdb->prefix . 'usermeta ( user_id, meta_key, meta_value ) VALUES ( $login_user, 'cookie', 'accepted' )")); */
			
			$wpdb->query($wpdb->prepare('INSERT INTO ' . $wpdb->prefix . 'usermeta ( user_id, meta_key, meta_value ) VALUES (%s, %s, %s)', array("$login_user", 'cookie', 'accepted')));
		}
		$cookie_count = $this->defaults['accepted_cookie_count'];
		$previous_count = get_option('accepted_cookie_count');
		update_option('accepted_cookie_count', $previous_count+1);
		 
		
	}
	
	/**
	 * Check if cookies are set.
	 *
	 * @return boolean Whether cookies are set
	 */
	public function cookies_set() {

		return apply_filters( 'cn_is_cookie_set', isset( $_COOKIE['opmc_gdpr_accepted'] ) );
	}
	
	/**
	 * Add WP Super Cache cookie.
	 */
	public function wpsc_add_cookie() {
		do_action( 'wpsc_add_cookie', 'opmc_gdpr_accepted' );
	}
	
	/**
	 * Delete WP Super Cache cookie.
	 */
	public function wpsc_delete_cookie() {
		do_action( 'wpsc_delete_cookie', 'opmc_gdpr_accepted' );
	}
		
	/**
	 * Get default settings.
	 */
	public function get_defaults() {
		return $this->defaults;
	}

	/**
	 * Add links to support forum.
	 * 
	 * @param array $links
	 * @param string $file
	 * @return array
	 */
	public function plugin_row_meta( $links, $file ) {
		if ( ! current_user_can( apply_filters( 'cn_manage_cookie_notice_cap', 'manage_options' ) ) ) {
			return $links;
		}

		if ( plugin_basename( __FILE__ ) == $file ) {
			return array_merge( $links, array( sprintf( '<a href="" target="_blank">%s</a>', __( 'Support', 'cookie-notice' ) ) ) );
		}

		return $links;
	}

	/**
	 * Add links to settings page.
	 * 
	 * @param array $links
	 * @param string $file
	 * @return array
	 */
	public function plugin_action_links( $links, $file ) {
		if ( ! current_user_can( apply_filters( 'cn_manage_cookie_notice_cap', 'manage_options' ) ) ) {
			return $links;
		}

		if ( plugin_basename( __FILE__ ) == $file ) {
			array_unshift( $links, sprintf( '<a href="%s">%s</a>', admin_url( 'admin.php?page=cookie-notice' ), __( 'Settings', 'opmc_gdpr' ) ) );
		}

		return $links;
	}

	/**
	 * Activate the plugin.
	 */
	public function activation() {
		add_option( 'cookie_notice_options', $this->defaults['general'], '', 'no' );
		add_option( 'cookie_notice_version', $this->defaults['version'], '', 'no' );
		global $wpdb;
			$charset_collate = $wpdb->get_charset_collate();
			require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

			//* Create the cookie table
			$cookie_name = $wpdb->prefix . 'cookie_info';
			$sql = "CREATE TABLE $cookie_name (
			id INTEGER NOT NULL AUTO_INCREMENT,
			user_name VARCHAR(255) NOT NULL,
			user_email VARCHAR(255) NOT NULL,
			user_role VARCHAR(255) NOT NULL,
			opmc_cookie_accpted VARCHAR(255) NOT NULL,
			opmc_cookie_unique_key VARCHAR(255) NOT NULL,
			opmc_cookie_user_type VARCHAR(255) NOT NULL,
			PRIMARY KEY (id)
			) $charset_collate;";
			dbDelta( $sql );
			
			//* Create the activity table
			$table_name = $wpdb->prefix . 'track_user_activity';
			$sql = "CREATE TABLE $table_name (
			id INTEGER NOT NULL AUTO_INCREMENT,
			cookie_id VARCHAR(255) NOT NULL,
			user_email VARCHAR(255) NOT NULL,
			page_url VARCHAR(255) NOT NULL,
			PRIMARY KEY (id)
			) $charset_collate;";
			dbDelta( $sql );
	}

	/**
	 * Deactivate the plugin.
	 */
	public function deactivation() {
		
		if ( 'yes' === $this->options['general']['deactivation_delete'] ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'track_user_activity';
			$wpdb->query('TRUNCATE ' . $wpdb->prefix . 'track_user_activity');
			$cookie_name = $wpdb->prefix . 'cookie_info';
			$wpdb->query('TRUNCATE ' . $wpdb->prefix . 'cookie_info');
			delete_option( 'cookie_notice_options' );
			delete_option( 'cookie_notice_version' );
			update_option( 'accepted_cookie_count', 0 );
			update_option( 'geo_country_list', '' );
			update_option( 'GA_tracking_id', '' );
			
		}
		
		// remove WP Super Cache cookie
		$this->wpsc_delete_cookie();
	}

	/**
	 * Get allowed script blocking HTML.
	 *
	 * @return array
	 */
	public function get_allowed_html() {
		return apply_filters(
			'cn_refuse_code_allowed_html',
			array_merge(
				wp_kses_allowed_html( 'post' ),
				array(
					'script' => array(
						'type' => array(),
						'src' => array(),
						'charset' => array(),
						'async' => array()
					),
					'noscript' => array(),
					'style' => array(
						'type' => array()
					),
					'iframe' => array(
						'src' => array(),
						'height' => array(),
						'width' => array(),
						'frameborder' => array(),
						'allowfullscreen' => array()
					)
				)
			)
		);
	}

	/**
	 * Load scripts and styles - admin.
	 */
	public function admin_enqueue_scripts( $page ) {
		if ( 'toplevel_page_cookie-notice' !== $page && 'woocommerce_page_cookie-notice' !== $page) {
			return;
		}

		wp_enqueue_script(
			'cookie-notice-admin', plugins_url( 'admin/js/admin' . ( ! ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '.min' : '' ) . '.js', __FILE__ ), array( 'jquery', 'wp-color-picker' ), $this->defaults['version']
		);
		
		wp_localize_script(
			'cookie-notice-admin', 'cnArgs', array(
				'resetToDefaults' => __( 'Are you sure you want to reset these settings to defaults?', 'cookie-notice' )
			)
		);

		wp_enqueue_style( 'wp-color-picker' );
		wp_enqueue_style( 'cookie-notice-admin', plugins_url( 'admin/css/admin' . ( ! ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '.min' : '' ) . '.css', __FILE__ ), array(), '1.1' );
	}

	/**
	 * Load scripts and styles - frontend.
	 */
	public function wp_enqueue_scripts() {
		wp_enqueue_script(
			'cookie-notice-front', plugins_url( 'admin/js/front' . ( ! ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '.min' : '' ) . '.js', __FILE__ ), array( 'jquery' ), $this->defaults['version'], isset( $this->options['general']['script_placement'] ) && 'footer' === $this->options['general']['script_placement'] ? true : false
		);
		
		wp_localize_script(
			'cookie-notice-front',
			'cnArgs',
			array(
				'ajaxurl' => admin_url( 'admin-ajax.php' ),
				'hideEffect' => $this->options['general']['hide_effect'],
				'onScroll' => $this->options['general']['on_scroll'],
				'onScrollOffset' => $this->options['general']['on_scroll_offset'],
				'cookieName' => 'opmc_gdpr_accepted',
				'cookieValue' => 'true',
				'cookieTime' => $this->times[$this->options['general']['time']][1],
				'cookiePath' => ( defined( 'COOKIEPATH' ) ? COOKIEPATH : '' ),
				'cookieDomain' => ( defined( 'COOKIE_DOMAIN' ) ? COOKIE_DOMAIN : '' ),
				'redirection' => $this->options['general']['redirection'],
				'cache' => defined( 'WP_CACHE' ) && WP_CACHE,
				'refuse' => $this->options['general']['refuse_opt'],
				'revoke_cookies' => (int) $this->options['general']['revoke_cookies'],
				'revoke_cookies_opt' => $this->options['general']['revoke_cookies_opt'],
				'secure' => (int) is_ssl()
			)
		);

		wp_enqueue_style( 'cookie-notice-front', plugins_url( 'admin/css/front' . ( ! ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '.min' : '' ) . '.css', __FILE__ ), array(), '1.1' );
	}

	/**
	 * Print non functional JavaScript in body.
	 *
	 * @return mixed
	 */
	public function wp_print_footer_scripts() {
		if ( $this->cookies_accepted() ) {
			$scripts = apply_filters( 'cn_refuse_code_scripts_html', html_entity_decode( trim( wp_kses( $this->options['general']['refuse_code'], $this->get_allowed_html() ) ) ) );
			if ( ! empty( $scripts ) ) {
				echo esc_html($scripts);
			}
		}
	}

	/**
	 * Print non functional JavaScript in header.
	 *
	 * @return mixed
	 */
	public function wp_print_header_scripts() {
		if ( $this->cookies_accepted() ) {
			$scripts = apply_filters( 'cn_refuse_code_scripts_html', html_entity_decode( trim( wp_kses( $this->options['general']['refuse_code_head'], $this->get_allowed_html() ) ) ) );

			if ( ! empty( $scripts ) ) {
				echo esc_html($scripts);
			}
		}
	} 
	
	/**
	 * Displays notices in admin.
	 *
	 * @return string Error notices. 
	 */
	
	public function admin_notices_gdpr_cookies() {
		
		$geo_country_list = get_option('geo_country_list');
		if (  empty( $geo_country_list ) ) {
			echo '<div class="error"><p>' . sprintf( /* translators: %s: documentation */  esc_html(__( 'Important! GDPR Cookies: Please set your required Geo Location to enable functionality. See our %s for guidance.', 'GDPR Cookies' )), '<a href="https://docs.woocommerce.com/document/woocommerce-gdpr-cookies-documentation/#section-6" target="_blank">' . esc_html(__( 'documentation', 'GDPR Cookies' )) . '</a>' ) . '</p></div>';
		}
	}
	
}

?>
